package com.example.iasaelectronica.wifi2ctrl;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.graphics.Color;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.provider.Settings;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.View;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Switch;
import android.widget.CompoundButton;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.SeekBar;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.UnknownHostException;
import java.time.Instant;
import java.util.ArrayList;
import java.util.Timer;
import java.util.TimerTask;

public class MainActivity extends AppCompatActivity {
    Switch SwitchRele1, SwitchRele2, SwitchRele3, SwitchRele4, SwitchRele5, SwitchRele6, SwitchRele7, SwitchRele8;
    Button BotonConectar, BotonLeerADC, BotonLeerPorts,BotonLeerReles,BotonGrabarDAC;
    TextView TxtEnviado, TxtRespuesta, AD1, AD2, AD3,IpConexion,PuertoConexion;
    CheckBox Input1, Input2, Input3, Input4, Input5, Input6, Input7, Input8;
    EditText IPDestino, PuertoDestino,ValorDAC;
    SeekBar DACSeekBar;
    private static Socket s;
    private static InputStreamReader isr;
    private static BufferedReader br;
    private static byte[] message;//mensaje a enviar por el net
    private static byte[] mensaje;
    private static String messager;//mensaje a leer por el net
    private static PrintWriter printWriter;
    MediaPlayer mp;
    MediaPlayer mp2;
    MediaPlayer ok;
    MediaPlayer error;
    private Timer mTimer1;
    private TimerTask mTt1;
    private Handler mTimerHandler = new Handler();
    String ValorReles = "000";
    String ValorEntradas = "000";
    String ValorAD1 = "0000";
    String ValorAD2 = "0000";
    String ValorAD3 = "0000";
    String ValDAC = "0000";
    private static String dip1,port1,ssidmc,passmc,ipmc,gwmc,msmc,ssidap,passap,canal,seguridad;
    String dhcpsn="N";
    String poscanal="0";
    String posseguridad="0";
    private static boolean nodisparo;

    ////////timer//////////////////////////
    private void stopTimer() {
        if (mTimer1 != null) {
            mTimer1.cancel();
            mTimer1.purge();
        }
    }

    private void startTimer() {
        mTimer1 = new Timer();
        mTt1 = new TimerTask() {
            public void run() {
                mTimerHandler.post(new Runnable() {
                    public void run() { /////to do////////
                        boolean resul = GetEstadosADC();
                        // boolean resul2 = GetEntradas();
                    }
                });
            }
        };

        mTimer1.schedule(mTt1, 1, 2000);
    }

    /////////////////RUTINAS DE ALMACENAMIENTO DE DATOS////////////////////////
    //   public class Almacenamiento{

    public void cargarpreferencias() {
        SharedPreferences pref = getApplicationContext().getSharedPreferences("NetPref", MODE_PRIVATE);
        dip1=pref.getString("dir1","0.0.0.0");
        port1=pref.getString("port1","0000");
        ssidmc=pref.getString("ssidmc","");
        passmc=pref.getString("passmc","......");
        ipmc=pref.getString("ipmc","0.0.0.0");
        gwmc=pref.getString("gwmc","0.0.0.0");
        msmc=pref.getString("msmc","0.0.0.0");
        dhcpsn=pref.getString("dhcpsn","N");
        poscanal=pref.getString("canal","10");
        posseguridad=pref.getString("seguridad","2");
        ssidap=pref.getString("ssidap","");
        passap=pref.getString("passap","......");
    }

    public void cargarestado() {
        SharedPreferences pref = getApplicationContext().getSharedPreferences("EstPref", MODE_PRIVATE);
        ValorReles=pref.getString("ValorReles","0000");
        ValorEntradas=pref.getString("ValorEntradas","0000");
        ValorAD1=pref.getString("ValorAD1","0000");
        ValorAD2=pref.getString("ValorAD2","0000");
        ValorAD3=pref.getString("ValorAD3","0000");
        ValDAC=pref.getString("ValDAC","0000");
    }

    public void guardarestado() {
        SharedPreferences pref = getApplicationContext().getSharedPreferences("EstPref", MODE_PRIVATE);
        SharedPreferences.Editor editor=pref.edit();
        editor.putString("ValorReles",ValorReles);
        editor.putString( "ValorEntradas",ValorEntradas);
        editor.putString( "ValorAD1",ValorAD1);
        editor.putString( "ValorAD2",ValorAD2);
        editor.putString( "ValorAD3",ValorAD3);
        editor.putString( "ValDAC",ValDAC);
        editor.commit();
    }

    public void habilitarbotones(){
        BotonGrabarDAC.setEnabled(true);
        BotonLeerPorts.setEnabled(true);
        BotonLeerADC.setEnabled(true);
        BotonLeerReles.setEnabled(true);

    }

    public void deshabiltarbotones(){
        BotonGrabarDAC.setEnabled(false);
        BotonLeerPorts.setEnabled(false);
        BotonLeerADC.setEnabled(false);
        BotonLeerReles.setEnabled(false);
    }

//////////////////////////////////////////////////////
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        setVolumeControlStream(AudioManager.STREAM_MUSIC);//para habilitar el control de volumen media

        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        SwitchRele1 = (Switch) findViewById(R.id.rele1);
        SwitchRele2 = (Switch) findViewById(R.id.rele2);
        SwitchRele3 = (Switch) findViewById(R.id.rele3);
        SwitchRele4 = (Switch) findViewById(R.id.rele4);
        SwitchRele5 = (Switch) findViewById(R.id.rele5);
        SwitchRele6 = (Switch) findViewById(R.id.rele6);
        SwitchRele7 = (Switch) findViewById(R.id.rele7);
        SwitchRele8 = (Switch) findViewById(R.id.rele8);
        BotonConectar = (Button) findViewById(R.id.botonconectar);
        BotonLeerADC = (Button) findViewById(R.id.leeradc);
        BotonLeerPorts = (Button) findViewById(R.id.leerports);
        BotonLeerReles = (Button) findViewById(R.id.leerreles);
        BotonGrabarDAC = (Button) findViewById(R.id.grabardac);
       // TxtEnviado = (TextView) findViewById(R.id.txtenviado);
       // TxtRespuesta = (TextView) findViewById(R.id.txtrespuesta);
        IpConexion = (TextView) findViewById(R.id.ipconexion);
        PuertoConexion = (TextView) findViewById(R.id.puertoconexion);
        DACSeekBar=(SeekBar)findViewById(R.id.seekBar);

        AD1 = (TextView) findViewById(R.id.ad1);
        AD2 = (TextView) findViewById(R.id.ad2);
        AD3 = (TextView) findViewById(R.id.ad3);
        ValorDAC = (EditText) findViewById(R.id.valordac);
        Input1 = (CheckBox) findViewById(R.id.input1);
        Input2 = (CheckBox) findViewById(R.id.input2);
        Input3 = (CheckBox) findViewById(R.id.input3);
        Input4 = (CheckBox) findViewById(R.id.input4);
        Input5 = (CheckBox) findViewById(R.id.input5);
        Input6 = (CheckBox) findViewById(R.id.input6);
        Input7 = (CheckBox) findViewById(R.id.input7);
        Input8 = (CheckBox) findViewById(R.id.input8);
        setSupportActionBar(toolbar);
        mp = MediaPlayer.create(this, R.raw.click4);
        mp2 = MediaPlayer.create(this, R.raw.alarma2);
        ok = MediaPlayer.create(this, R.raw.correct1);
        error = MediaPlayer.create(this, R.raw.error1);
        // IPDestino=(EditText) findViewById(R.id.ipdestino);
        // PuertoDestino=(EditText) findViewById(R.id.puertodestino);

//////////funciones de reles////////////
        SwitchRele1.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton compoundButton, boolean bChecked) {
                if (nodisparo == false) {
                    if (bChecked) {
                        // Toast.makeText(getApplicationContext(), "RELE 1 ACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE1=1\r\n";
                        message = str.getBytes();
                        send_text();
                    } else {
                        //Toast.makeText(getApplicationContext(), "RELE 1 INACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE1=0\r\n";
                        message = str.getBytes();
                        send_text();
                    }
                    Log.e("TCP", "BOTON DE RELE 1 : " + new String(message));
                }
            }
        });
        SwitchRele2.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton compoundButton, boolean bChecked) {
                if (nodisparo == false) {
                    if (bChecked) {
                        //Toast.makeText(getApplicationContext(), "RELE 2 ACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE2=1\r\n";
                        message = str.getBytes();
                        send_text();
                    } else {
                        //Toast.makeText(getApplicationContext(), "RELE 2 INACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE2=0\r\n";
                        message = str.getBytes();
                        send_text();
                    }
                    Log.e("TCP", "BOTON DE RELE 2 : " + new String(message));
                }
            }
        });
        SwitchRele3.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton compoundButton, boolean bChecked) {
                if (nodisparo == false) {
                    if (bChecked) {
                        //Toast.makeText(getApplicationContext(), "RELE 3 ACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE3=1\r\n";
                        message = str.getBytes();
                        send_text();
                    } else {
                        //Toast.makeText(getApplicationContext(), "RELE 3 INACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE3=0\r\n";
                        message = str.getBytes();
                        send_text();
                    }
                    Log.e("TCP", "BOTON DE RELE 3 : " + new String(message));
                }
            }
        });
        SwitchRele4.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
                public void onCheckedChanged(CompoundButton compoundButton, boolean bChecked) {
                if (nodisparo == false) {
                    if (bChecked) {
                        //Toast.makeText(getApplicationContext(), "RELE 4 ACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE4=1\r\n";
                        message = str.getBytes();
                        send_text();
                    } else {
                        //Toast.makeText(getApplicationContext(), "RELE 4 INACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE4=0\r\n";
                        message = str.getBytes();
                        send_text();
                    }
                    Log.e("TCP", "BOTON DE RELE 4 : " + new String(message));
                }
            }
        });
        SwitchRele5.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton compoundButton, boolean bChecked) {
                if (nodisparo == false) {
                    if (bChecked) {
                        //Toast.makeText(getApplicationContext(), "RELE 5 ACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE5=1\r\n";
                        message = str.getBytes();
                        send_text();
                    } else {
                        //Toast.makeText(getApplicationContext(), "RELE 5 INACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE5=0\r\n";
                        message = str.getBytes();
                        send_text();
                    }
                    Log.e("TCP", "BOTON DE RELE 5 : " + new String(message));
                }
            }
        });
        SwitchRele6.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton compoundButton, boolean bChecked) {
                if (nodisparo == false) {
                    if (bChecked) {
                        //Toast.makeText(getApplicationContext(), "RELE 6 ACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE6=1\r\n";
                        message = str.getBytes();
                        send_text();
                    } else {
                        //Toast.makeText(getApplicationContext(), "RELE 6 INACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE6=0\r\n";
                        message = str.getBytes();
                        send_text();
                    }
                    Log.e("TCP", "BOTON DE RELE 6 : " + new String(message));
                }
            }
        });
        SwitchRele7.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton compoundButton, boolean bChecked) {
                if (nodisparo == false) {
                    if (bChecked) {
                        //Toast.makeText(getApplicationContext(), "RELE 7 ACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE7=1\r\n";
                        message = str.getBytes();
                        send_text();
                    } else {
                        //Toast.makeText(getApplicationContext(), "RELE 7 INACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE7=0\r\n";
                        message = str.getBytes();
                        send_text();
                    }
                    Log.e("TCP", "BOTON DE RELE 7 : " + new String(message));
                }
            }
        });
        SwitchRele8.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton compoundButton, boolean bChecked) {
                if (nodisparo == false) {
                    if (bChecked) {
                        //Toast.makeText(getApplicationContext(), "RELE 8 ACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE8=1\r\n";
                        message = str.getBytes();
                        send_text();
                    } else {
                        //Toast.makeText(getApplicationContext(), "RELE 8 INACTIVO", Toast.LENGTH_SHORT).show();
                        String str = "SET_RELE8=0\r\n";
                        message = str.getBytes();
                        send_text();
                    }
                    Log.e("TCP", "BOTON DE RELE 8 : " + new String(message));
                }
            }
        });

//////////boton conectar///////////////////
        BotonConectar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
                BotonConectar.setText("CONECTANDO...");
                Toast.makeText(getApplicationContext(), "CONECTANDO...", Toast.LENGTH_SHORT).show();
                mp.start();//sonido boton
                boolean resul = false;
                int intentos = 0;
                boolean exito=false;

                while((resul==false)&&(intentos<5)){
                    resul = GetEstadosRelays();
                    intentos +=1;
                }
                if(resul==true){
                    BotonLeerReles.setTextColor(Color.argb(200, 20, 200, 20));
                    exito=true;
                }

                if (exito == true) {
                    IpConexion.setText(dip1.toString());
                    PuertoConexion.setText(port1);
                    ok.start();//sonido
                    BotonConectar.setTextColor(Color.argb(200, 20, 200, 20));
                    Toast.makeText(getApplicationContext(), "CONECTADO :) " + "IP:" + dip1 + " PUERTO:" + port1, Toast.LENGTH_SHORT).show();
                    BotonConectar.setText("CONECTADO");
                    habilitarbotones();

                } else {
                    error.start();
                    BotonConectar.setTextColor(Color.argb(240, 240, 0, 0));
                    BotonConectar.setText("CONECTAR");
                    Toast.makeText(getApplicationContext(), "ERROR DE CONEXION!!! " + "IP:" + dip1 + " PUERTO:" + port1, Toast.LENGTH_SHORT).show();
                    deshabiltarbotones();
                }
            }
        });
///////////////////////////////////////////
        //////////boton leer adc///////////////////
        BotonLeerADC.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
                mp.start();//sonido boton
                boolean resul = false;
                resul = GetEstadosADC();
                if (resul == true) {
                    //ok.start();//sonido
                    BotonLeerADC.setTextColor(Color.argb(200, 20, 200, 20));
                } else {
                    error.start();
                    BotonLeerADC.setTextColor(Color.argb(240, 240, 0, 0));
                    Toast.makeText(getApplicationContext(), "ERROR AL LEER ADC!!! " + "IP:" + dip1 + " PUERTO:" + port1, Toast.LENGTH_SHORT).show();

                }
            }
        });
///////////////////////////////////////////
        //////////boton leer entradas///////////////////
        BotonLeerPorts.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
                mp.start();//sonido boton
                boolean resul = false;
                resul = GetEntradas();
                if (resul == true) {
                    //ok.start();//sonido
                    BotonLeerPorts.setTextColor(Color.argb(200, 20, 200, 20));

                } else {
                    error.start();
                    BotonLeerPorts.setTextColor(Color.argb(240, 240, 0, 0));
                    Toast.makeText(getApplicationContext(), "ERROR AL LEER ENTRADAS!!! " + "IP:" + dip1 + " PUERTO:" + port1, Toast.LENGTH_SHORT).show();
                }
            }
        });
///////////////////////////////////////////
        //////////boton leer reles///////////////////
        BotonLeerReles.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
                mp.start();//sonido boton
                boolean resul = false;
                resul = GetEstadosRelays();
                if (resul == true) {
                    //ok.start();//sonido
                    BotonLeerReles.setTextColor(Color.argb(200, 20, 200, 20));
                } else {
                    error.start();
                    BotonLeerReles.setTextColor(Color.argb(240, 240, 0, 0));
                    Toast.makeText(getApplicationContext(), "ERROR AL LEER RELES!!! " + "IP:" + dip1 + " PUERTO:" + port1, Toast.LENGTH_SHORT).show();
                }
            }
        });
        //////////boton set DAC///////////////////
        BotonGrabarDAC.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
                mp.start();//sonido boton
                boolean resul = false;
                resul = SetValorDAC();
                if (resul == true) {
                    //ok.start();//sonido
                    BotonGrabarDAC.setTextColor(Color.argb(200, 20, 200, 20));
                } else {
                    error.start();
                    BotonGrabarDAC.setTextColor(Color.argb(240, 240, 0, 0));
                    Toast.makeText(getApplicationContext(), "ERROR AL GRABAR DAC!!! " + "IP:" + dip1 + " PUERTO:" + port1, Toast.LENGTH_SHORT).show();
                }
            }
        });
//////////////////DAC SeekBar//////////////////////////
        DACSeekBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            int progressChangedValue = 0;

            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                progressChangedValue = progress;
                ValorDAC.setText(Integer.toString(progressChangedValue));
            }

            public void onStartTrackingTouch(SeekBar seekBar) {
                // TODO Auto-generated method stub
            }

            public void onStopTrackingTouch(SeekBar seekBar) {

               // Toast.makeText(MainActivity.this, "Seek bar progress is :" + progressChangedValue, Toast.LENGTH_SHORT).show();

            }
        });
        ValorDAC.addTextChangedListener(new TextWatcher() {
            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                String Sval2= ValorDAC.getText().toString();
                int val2 = convertStringToInt(Sval2);
                if(val2>4095){
                    ValorDAC.setText("4095");
                }
            }
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
            }
            @Override
            public void afterTextChanged(Editable s) {
                if(ValorDAC.getText().length() >= 0) {
                    String Sval= ValorDAC.getText().toString();
                    int val = convertStringToInt(Sval);
                    DACSeekBar.setProgress(val);
                    ValorDAC.setSelection(ValorDAC.getText().length());
                }
            }
        });

////////////////////////////////////////////
        cargarpreferencias();///carga datos de inicio
     //   ActualizaDisplay();  //lee datos guardados de los estados para recuperar la pantalla
///////////////////////////////////////////
        IpConexion.setText(dip1.toString());
        PuertoConexion.setText(port1.toString());
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    //////Seleccion de actividades//////
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        int id = item.getItemId();
        Intent i;

        switch(item.getItemId()) {
            case R.id.confip:
                i = new Intent(MainActivity.this, ConfigNetActivity.class);
                startActivity(i);
                return true;
            case R.id.confhora:
                i = new Intent(MainActivity.this, ConfigTimeActivity.class);
                startActivity(i);
                return true;
            case R.id.action_settings:
                i = new Intent(MainActivity.this, ConfigActivity.class);
                startActivity(i);
                return true;
        }
        return super.onOptionsItemSelected(item);
    }
    //////////////rutinas auxiliares/////////////////////////////////
    public static void espera(int miliseg) {
        long start = System.currentTimeMillis();
        long end = start + miliseg;
        while(true) {
            if(System.currentTimeMillis() > end) {
                break;
            }
        }
    }

    public static int convertStringToInt(String numero) {
        int parse_numero = 0;
        try {
            parse_numero = Integer.parseInt(numero);

        } catch (NumberFormatException e) {

        }
        return parse_numero;
    }
///////////////////////////////////////////////////
///////////////comunicaciones//////////////////////

    public boolean GetEntradas() {

        String str = "GET_PORTS\r\n";
        message = str.getBytes();
        send_text();
        Log.e("TCP", "S:PORTS. MENSAJE ENVIADO: " + new String(message));
        messager="ERROR GET PORTS";
        espera(1000);
        String estado="KK";
        String bien ="Ok";
        boolean resultado = false;
        try {
            estado = messager.substring(0, 2);
        }catch (Exception e){
            Log.e("TCP", "ERROR ADC al analizar messager: " + new String(message));
        }
        if(estado.intern()!=bien.intern()) {
            resultado=false;
        }else{
            resultado=true;
        }
        if (resultado == true) {
            str = messager;
            str = str.replaceAll("(Ok)", "");
            ValorEntradas = str;
            Log.e("TCP", "S: MENSAJE RECIBIDO PORTS: " + messager);
            int variableports = convertStringToInt(str);
            for (int cont = 0; cont < 8; cont++) {
                if ((variableports & (1 << cont)) > 0) {
                    switch (cont) {
                        case 0: {
                            Input1.setChecked(true);
                            break;
                        }
                        case 1: {
                            Input2.setChecked(true);
                            break;
                        }
                        case 2: {
                            Input3.setChecked(true);
                            break;
                        }
                        case 3: {
                            Input4.setChecked(true);
                            break;
                        }
                        case 4: {
                            Input5.setChecked(true);
                            break;
                        }
                        case 5: {
                            Input6.setChecked(true);
                            break;
                        }
                        case 6: {
                            Input7.setChecked(true);
                            break;
                        }
                        case 7: {
                            Input8.setChecked(true);
                            break;
                        }
                    }
                } else {
                    switch (cont) {
                        case 0: {
                            Input1.setChecked(false);
                            break;
                        }
                        case 1: {
                            Input2.setChecked(false);
                            break;
                        }
                        case 2: {
                            Input3.setChecked(false);
                            break;
                        }
                        case 3: {
                            Input4.setChecked(false);
                            break;
                        }
                        case 4: {
                            Input5.setChecked(false);
                            break;
                        }
                        case 5: {
                            Input6.setChecked(false);
                            break;
                        }
                        case 6: {
                            Input7.setChecked(false);
                            break;
                        }
                        case 7: {
                            Input8.setChecked(false);
                            break;
                        }
                    }
                }
            }
            guardarestado();
            }else{
                Log.e("TCP", "S: ERROR PORTS. MENSAJE RECIBIDO: " + messager);
                resultado=false;
            }

        return resultado;
    }

    public boolean GetEstadosADC() {
        String str = "GET_ADC\r\n";
        message = str.getBytes();
        send_text();
        Log.e("TCP", "S:ADC. MENSAJE ENVIADO: " + new String(message));
        messager="ERROR GET ADC";
        espera(1000);
        String estado="KK";
        String bien ="Ok";
        boolean resultado = false;
        try {
            estado = messager.substring(0, 2);
        }catch (Exception e){
            Log.e("TCP", "ERROR ADC al analizar messager: " + new String(message));
        }
        if(estado.intern()!=bien.intern()) {
            resultado=false;
        }else{
            resultado=true;
        }
        if (resultado == true) {
            str = messager;
            str = str.replaceAll("(Ok)", "");
            Log.e("TCP", "S: MENSAJE RECIBIDO ADC: " + messager);
            int longitud = str.length();
            if (longitud >= 12) {
                ValorAD1 = str.substring(0, 4);
                ValorAD2 = str.substring(4, 8);
                ValorAD3 = str.substring(8, 12);
                AD1.setText(ValorAD1);
                AD2.setText(ValorAD2);
                AD3.setText(ValorAD3);
                Log.e("TCP", "S: ADC1: " + ValorAD1);
                Log.e("TCP", "S: ADC2: " + ValorAD2);
                Log.e("TCP", "S: ADC3: " + ValorAD3);
            }else{
                Log.e("TCP", "S: ERROR ADC. MENSAJE RECIBIDO: " + messager);
                resultado=false;
            }
            guardarestado();
        }
        else{
            Log.e("TCP", "S: ERROR ADC. MENSAJE RECIBIDO: " + messager);
            resultado=false;
        }
        return resultado;
    }

    public boolean GetEstadosRelays()
    {
        nodisparo=true;
        String str="GET_RELES\r\n";
        message = str.getBytes();
        Log.e("TCP", "S:RELES. MENSAJE ENVIADO: " + new String(message)+ " IP: " + dip1 + " PUERTO: " + port1);
        messager="ERROR GET RELES";
        send_text();
        espera(1000);
        String estado="KK";
        String bien ="Ok";
        boolean resultado = false;
        try {
            estado = messager.substring(0, 2);
        }catch (Exception e){
            Log.e("TCP", "ERROR al analizar messager: " + new String(message));
        }
        if(estado.intern()!=bien.intern()) {
            resultado=false;
        }else{
            resultado=true;
        }
        if(resultado==true) {
            str = messager;
            str = str.replaceAll("(Ok)", "");
            ValorReles=str;
            int variablereles = convertStringToInt(str);
            Log.e("TCP", "S: MENSAJE RECIBIDO RELES: " + messager);
            for (int cont = 0; cont < 8; cont++) {
                if ((variablereles & (1 << cont)) > 0) {
                    switch (cont) {
                        case 0: {
                            SwitchRele1.setChecked(true);
                            break;
                        }
                        case 1: {
                            SwitchRele2.setChecked(true);
                            break;
                        }
                        case 2: {
                            SwitchRele3.setChecked(true);
                            break;
                        }
                        case 3: {
                            SwitchRele4.setChecked(true);
                            break;
                        }
                        case 4: {
                            Log.e("TCP", "prueba 5 : " + new String(message));
                            SwitchRele5.setChecked(true);
                            break;
                        }
                        case 5: {
                            SwitchRele6.setChecked(true);
                            break;
                        }
                        case 6: {
                            SwitchRele7.setChecked(true);
                            break;
                        }
                        case 7: {
                            SwitchRele8.setChecked(true);
                            break;
                        }
                    }
                } else {
                    switch (cont) {
                        case 0: {
                            SwitchRele1.setChecked(false);
                            break;
                        }
                        case 1: {
                            SwitchRele2.setChecked(false);
                            break;
                        }
                        case 2: {
                            SwitchRele3.setChecked(false);
                            break;
                        }
                        case 3: {
                            SwitchRele4.setChecked(false);
                            break;
                        }
                        case 4: {
                            SwitchRele5.setChecked(false);
                            break;
                        }
                        case 5: {
                            SwitchRele6.setChecked(false);
                            break;
                        }
                        case 6: {
                            SwitchRele7.setChecked(false);
                            break;
                        }
                        case 7: {
                            SwitchRele8.setChecked(false);
                            break;
                        }
                    }
                }
            }
            guardarestado();
            resultado=true;
        }
        else{
            Log.e("TCP", "S: ERROR RELES. MENSAJE RECIBIDO: " + messager);
            resultado=false;
        }
        nodisparo=false;
        return resultado;
    }
    public boolean SetValorDAC() {
        String Sval3= ValorDAC.getText().toString();
        ValDAC = Sval3;
        String str = "SET_DAC=" + Sval3;
        message = str.getBytes();
        send_text();
        Log.e("TCP", "S:SET DAC. MENSAJE ENVIADO: " + new String(message));
        messager="ERROR SET DAC";
        espera(1000);
        String estado="KK";
        String bien ="Ok";
        boolean resultado = false;
        try {
            estado = messager.substring(0, 2);
        }catch (Exception e){
            Log.e("TCP", "ERROR DAC al analizar messager: " + new String(message));
        }
        if(estado.intern()!=bien.intern()) {
            resultado=false;
        }else{
            resultado=true;
        }
        if (resultado == true) {

            Toast.makeText(MainActivity.this, "VALOR DAC ESTABLECIDO EN :" + Sval3, Toast.LENGTH_SHORT).show();

            guardarestado();
        }
        else{
            Log.e("TCP", "S: ERROR ADC. MENSAJE RECIBIDO: " + messager);
            Toast.makeText(MainActivity.this, "ERROR AL ESTABLECER VALOR DAC :(", Toast.LENGTH_SHORT).show();
            resultado=false;
        }
        return resultado;
    }
    /////////////////////////////////////////////////////////////////////////
    ///////////funciones llamadas desde ConfigActivity///////////////////////
    public static boolean SetConfiguracionAP(Context context, String port, int modo, String dhcpsn,
                                             String ip, String gw, String ms, String SSIDmc, String passmc,
                                             String SSIDAP, String passAP,String canal,String posseguridad)
    {

        ///////////setado del puerto
        messager="ERROR CONFIG NET";
        int puerto =convertStringToInt(port);
        String str= "SET_SERVER_PORT=1500";
        String comando="";
        int ret;
        message = new byte[20];
        message = str.getBytes();
        message[16]=(byte)((puerto >> 24) & 0xff);
        message[17]=(byte)((puerto >> 16) & 0xff);
        message[18]=(byte)((puerto >> 8) & 0xff);
        message[19]=(byte)((puerto & 0xff));
        Log.e("TCP", "S: MENSAJE ENVIADO SET PORT: " + new String(message));
        send_text();
        espera(1000);
        String estado="KK";
        String bien ="Ok";
        boolean resultado = false;
        try {
            estado = messager.substring(0, 2);
        }catch (Exception e){
            Log.e("TCP", "S: ERROR al analizar messager: " + new String(message));
        }
        if(estado.intern()!=bien.intern()) {
            resultado=false;
        }else{
            resultado=true;
        }
        if (resultado == true) {
            str = messager;
            str = str.replaceAll("(Ok)", "");
            Log.e("TCP", "S: MENSAJE RECIBIDO SET PORT: " + messager);

        }else{
            Log.e("TCP", "S: ERROR SET PORT. MENSAJE RECIBIDO: " + messager);
            resultado=false;
        }
/////////////seteado de los otros parametros////////////////
        if(modo==0)/////////////modo cliente////////
        {
            comando = "AT_START>AT+CWMODE_DEF=1\r\n";
            String si="S";
            if(dhcpsn.intern()==si.intern()){
                comando += "AT+CWDHCP_DEF=1,1\r\n";
            }
            else
            {
                comando += "AT+CWDHCP_DEF=1,0\r\n";
                comando += "AT+CIPSTA_DEF=\"" + ip + "\",\"" + gw + "\",\"" + ms + "\"\r\n";
            }
            comando += "AT+CWJAP_DEF=\"" + SSIDmc + "\",\"" + passmc + "\"\r\n";
            comando += "AT+RST\r\n";
        }else {/////////modo softAP/////////
            comando = "AT_START>AT+CWMODE_DEF=2\r\n";
            comando += "AT+CWDHCP_DEF=0,1\r\n";
            comando += "AT+CWSAP_DEF=\"" + SSIDAP + "\",\"" + passAP + "\"," + canal+ "," + posseguridad + "\r\n";
            comando += "AT+RST\r\n";
        }
        message = new byte[comando.length()];
        message = comando.getBytes();
        Log.e("TCP", "S: COMANDO TOTAL ENVIADO: " + new String(message));
        send_text();
        espera(1000);
        estado="KK";
        bien ="Ok";
        resultado = false;
        try {
            estado = messager.substring(0, 2);
        }catch (Exception e){
            Log.e("TCP", "S: ERROR al analizar messager2: " + new String(message));
        }
        if(estado.intern()!=bien.intern()) {
            resultado=false;
        }else{
            resultado=true;
        }
        if (resultado == true) {
            str = messager;
            str = str.replaceAll("(Ok)", "");
            Log.e("TCP", "S: MENSAJE RECIBIDO DESPUES DEL COMANDO TOTAL: " + messager);
            //Toast.makeText(context, "MENSAJE RECIBIDO SET PORT:"+messager, Toast.LENGTH_SHORT).show();

        }else{
            Log.e("TCP", "S: ERROR COMANDO TOTAL. MENSAJE RECIBIDO: " + messager);
            resultado=false;
        }

        return resultado;
    }
/////////////////////////////////////////////////////////////////////////////////
///////////funciones llamadas desde ConfigTimeActivity///////////////////////
public static int GetRTC(Context context)
{
    String str = "GET_RTC\r\n";
    message = str.getBytes();
    send_text();
    Log.e("TCP", "S:SET RTC. MENSAJE ENVIADO: " + new String(message));
    messager="ERROR GET RTC";
    espera(1000);
    String estado="KK";
    String bien ="Ok";
    boolean resultado = false;
    try {
        estado = messager.substring(0, 2);
    }catch (Exception e){
        Log.e("TCP", "ERROR GET RTC al analizar messager: " + new String(message));
    }
    if(estado.intern()!=bien.intern()) {
        resultado=false;
    }else{
        resultado=true;
    }
    if (resultado == true) {
        str = messager;
        str = str.replaceAll("(Ok)", "");
        int longitud = str.length();
        Log.e("TCP", "S: MENSAJE RECIBIDO GET RTC: " + messager+" Longitud: " + Integer.toString(longitud));

        }else{
            Log.e("TCP", "S: ERROR GET RTC MENSAJE RECIBIDO: " + messager);
            resultado=false;
        }
    int r=123456;
    return r;
}

    public static boolean SetRTC(Context context, Integer epoch)
    {
        String RTCval = Integer.toString(epoch);
        Log.e("TCP", "S:SET RTC. EPOCH: " + RTCval);
        String str= "SET_RTC=0000";
        String comando="";
        int ret;
        message = new byte[12];
        message = str.getBytes();
        message[8]=(byte)((epoch >> 24) & 0xff);
        message[9]=(byte)((epoch >> 16) & 0xff);
        message[10]=(byte)((epoch >> 8) & 0xff);
        message[11]=(byte)((epoch & 0xff));

        send_text();
        Log.e("TCP", "S:SET RTC. MENSAJE ENVIADO: " + new String(message));
        messager="ERROR SET RTC";
        espera(1000);
        String estado="KK";
        String bien ="Ok";
        boolean resultado = false;
        try {
            estado = messager.substring(0, 2);
        }catch (Exception e){
            Log.e("TCP", "ERROR SET RTC al analizar messager: " + new String(message));
        }
        if(estado.intern()!=bien.intern()) {
            resultado=false;
        }else{
            resultado=true;
        }
        if (resultado == true) {

            //Toast.makeText(MainActivity.this, "VALOR RTC ESTABLECIDO EN :" + Sval3, Toast.LENGTH_SHORT).show();

            //guardarestado();
        }
        else{
            Log.e("TCP", "S: ERROR RTC. MENSAJE RECIBIDO: " + messager);
            //Toast.makeText(MainActivity.this, "ERROR AL ESTABLECER VALOR DAC :(", Toast.LENGTH_SHORT).show();
            resultado=false;
        }
        Log.e("TCP", "S: SALIO: " + resultado);
        return resultado;
    }
////////////////////////////////////////////////////////////////////////////////////////////////

    public static void send_text() {
        MyTask mt=new MyTask();
        mt.execute();
    }

    static class MyTask extends AsyncTask<Void,Void,String> {
        @Override
        protected String doInBackground(Void... params) {
            try {
                char[] data= new char[100];
                boolean end = false;
                int port = Integer.parseInt(port1);
               // s = new Socket(dip1.toString(), port);

                s = new Socket();
                s.connect(new InetSocketAddress(dip1.toString(), port), 5000);

                br = new BufferedReader(new InputStreamReader(s.getInputStream()));
                OutputStream out = s.getOutputStream();
                out.write(message,0,message.length);
                messager = br.readLine();
                out.close();
                br.close();
                s.close();
            } catch (UnknownHostException e) {
                      Log.e("TCP", "S: ERROR1: '" + e.toString());
            } catch (IOException e) {
                Log.e("TCP", "S: ERROR2: '" + e.toString());
            } finally {
                if (s != null) {
                    try {
                        s.close();
                    } catch (IOException e) {
                        Log.e("TCP", "S: ERROR3: '" + e.toString());
                }
            }
        }
            return messager;
        }

        @Override
        protected void onPostExecute(String s) {
           // Log.e("TCP", "S: MENSAJE ENVIADO EN POST: " + new String(message));
           // Log.e("TCP", "S: MENSAJE RECIBIDO EN POST: " + messager);
            //TxtEnviado.setText("ENVIADO: "+message.replaceAll("(\\r|\\n)", ""));
            //TxtRespuesta.setText("RECIBIDO POST: "+s.replaceAll("(\\r|\\n)", ""));
        }
    }
    ////////////////////////////////////////////////////
}
